/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.campaigngetter;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 *
 * @author Andrei
 */
public class GetterRunner implements Runnable{

    private int pageNumber;
  
    public static Set<Campaign> campaigns = Collections.synchronizedSet(new HashSet<Campaign>());
    
    public GetterRunner(int pageNumber){
        this.pageNumber=pageNumber;
    }
    @Override
    public void run() {
        try {
            Document spacehive = Jsoup.connect("https://www.spacehive.com/discoverprojects?page="+pageNumber).get();
            //System.out.println(spacehive.getElementsByClass("panel-body"));
            Elements elements = spacehive.getElementsByClass("panel-body");
            for (Element element: elements ){
                
                String name = element.select("h4").text();
                String description = element.select("p").text();
                campaigns.add(new Campaign(name,description));
                
                
            }
            
        } catch (IOException ex) {
            Logger.getLogger(GetterRunner.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    private CampaignCategory getCategory(int category){
        switch(category){
            case 1:
                return CampaignCategory.SPORTS;
            case 2:
                return CampaignCategory.PARKS;
            case 3:
                return CampaignCategory.ARTS;
            case 4:
                return CampaignCategory.BUILDINGS;
            case 5:
                return CampaignCategory.FOOD;
            case 6:
                return CampaignCategory.INFRASTRUCTURE;
            default:
                return null;
        }
    }
    
    
}
